<?php
class ControllerModuleExpireOrders extends Controller {
    private $error = array(); 
	 
    public function index() {   
        $this->load->language('module/expire_orders');

        $this->document->setTitle($this->language->get('heading_title'));
		
        $this->load->model('setting/setting');
				
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('expire_orders', $this->request->post);		
            $this->session->data['success'] = $this->language->get('text_success');
            $this->redirect($this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'));
        }
				
        $this->data['token'] = $this->session->data['token'];

        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }

        $this->data['heading_title'] = $this->language->get('heading_title');
        $this->data['text_expire_days'] = $this->language->get('text_expire_days');
        $this->data['text_expire_status_to'] = $this->language->get('text_expire_status_to');
        $this->data['text_expire_status_from'] = $this->language->get('text_expire_status_from');
        $this->data['text_expire_notify'] = $this->language->get('text_expire_notify');
        $this->data['text_expire_comment'] = $this->language->get('text_expire_comment');
        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');

        $this->data['action'] = $this->url->link('module/expire_orders', 'token=' . $this->session->data['token'], 'SSL');
        $this->data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['breadcrumbs'] = array();

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_home'),
            'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_module'),
            'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('heading_title'),
            'href'      => $this->url->link('module/expire_orders', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

		
        if (isset($this->request->post['expire_days'])) {
            $this->data['expire_days'] = $this->request->post['expire_days'];
        } elseif ($this->config->get('expire_days')) { 
            $this->data['expire_days'] = $this->config->get('expire_days');
        } else {
            $this->data['expire_days'] = 0;
        }

        if (isset($this->request->post['expire_status_from'])) {
            $this->data['expire_status_from'] = $this->request->post['expire_status_from'];
        } elseif ($this->config->get('expire_status_from')) {
            $this->data['expire_status_from'] = $this->config->get('expire_status_from');
        } else {
            $this->data['expire_status_from'] = 0;
        }

        if (isset($this->request->post['expire_status_to'])) {
            $this->data['expire_status_to'] = $this->request->post['expire_status_to'];
        } elseif ($this->config->get('expire_status_to')) {
            $this->data['expire_status_to'] = $this->config->get('expire_status_to');
        } else {
            $this->data['expire_status_to'] = 0;
        }

        if (isset($this->request->post['expire_comment'])) {
            $this->data['expire_comment'] = $this->request->post['expire_comment'];
        } elseif ($this->config->get('expire_comment')) {
            $this->data['expire_comment'] = $this->config->get('expire_comment');
        } else {
            $this->data['expire_comment'] = '';
        }

        if (isset($this->request->post['expire_notify'])) {
            $this->data['expire_notify'] = $this->request->post['expire_notify'];
        } elseif ($this->config->get('expire_notify')) {
            $this->data['expire_notify'] = $this->config->get('expire_notify');
        } else {
            $this->data['expire_notify'] = 0;
        }

        $this->load->model('localisation/order_status');
        $this->data['statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        $this->load->model('design/layout');
   
        $this->data['layouts'] = $this->model_design_layout->getLayouts();
				
		$this->template = 'module/expire_orders.tpl';

        $this->children = array(
            'common/header',
            'common/footer',
        );
				
        $this->response->setOutput($this->render());
    }
	
    private function validate() {
        if (!$this->user->hasPermission('modify', 'module/expire_orders')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (isset($this->request->post['expire_days']) && is_numeric($this->request->post['expire_days']) ) {
            if ( $this->request->post['expire_days'] < 0 || $this->request->post['expire_days'] > 30) {
                $this->error['warning'] = $this->language->get('error_out_of_range');
            }
        } else {
           $this->error['warning'] = $this->language->get('error_bad_value');
        }

        if (isset($this->request->post['expire_comment']) && strlen($this->request->post['expire_comment']) > 250) {
            $this->error['warning'] = $this->language->get('error_long_comment');
        }

        $this->request->post['expire_notify'] = (empty($this->request->post['expire_notify']) ? 0 : 1 );


        if (!$this->error) {
            return true;
        } else {
            return false;
        }	
    }
}
?>
